/* object.c generated by valac 0.44.0, the Vala compiler
 * generated from object.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gcr/gcr-base.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define SEAHORSE_TYPE_OBJECT (seahorse_object_get_type ())
#define SEAHORSE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_OBJECT, SeahorseObject))
#define SEAHORSE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_OBJECT, SeahorseObjectClass))
#define SEAHORSE_IS_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_OBJECT))
#define SEAHORSE_IS_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_OBJECT))
#define SEAHORSE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_OBJECT, SeahorseObjectClass))

typedef struct _SeahorseObject SeahorseObject;
typedef struct _SeahorseObjectClass SeahorseObjectClass;
typedef struct _SeahorseObjectPrivate SeahorseObjectPrivate;

#define SEAHORSE_TYPE_PLACE (seahorse_place_get_type ())
#define SEAHORSE_PLACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_PLACE, SeahorsePlace))
#define SEAHORSE_IS_PLACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_PLACE))
#define SEAHORSE_PLACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), SEAHORSE_TYPE_PLACE, SeahorsePlaceIface))

typedef struct _SeahorsePlace SeahorsePlace;
typedef struct _SeahorsePlaceIface SeahorsePlaceIface;
typedef enum  {
	SEAHORSE_USAGE_NONE = 0,
	SEAHORSE_USAGE_SYMMETRIC_KEY = 1,
	SEAHORSE_USAGE_PUBLIC_KEY = 2,
	SEAHORSE_USAGE_PRIVATE_KEY = 3,
	SEAHORSE_USAGE_CREDENTIALS = 4,
	SEAHORSE_USAGE_IDENTITY = 5,
	SEAHORSE_USAGE_OTHER = 10
} SeahorseUsage;

#define SEAHORSE_TYPE_USAGE (seahorse_usage_get_type ())
typedef enum  {
	SEAHORSE_FLAG_NONE = 0,
	SEAHORSE_FLAG_IS_VALID = 0x00000001,
	SEAHORSE_FLAG_CAN_ENCRYPT = 0x00000002,
	SEAHORSE_FLAG_CAN_SIGN = 0x00000004,
	SEAHORSE_FLAG_CAN_CERTIFY = 0x00000008,
	SEAHORSE_FLAG_CAN_AUTHENTICATE = 0x00000010,
	SEAHORSE_FLAG_EXPIRED = 0x00000100,
	SEAHORSE_FLAG_REVOKED = 0x00000200,
	SEAHORSE_FLAG_DISABLED = 0x00000400,
	SEAHORSE_FLAG_TRUSTED = 0x00001000,
	SEAHORSE_FLAG_PERSONAL = 0x00002000,
	SEAHORSE_FLAG_EXPORTABLE = 0x00100000,
	SEAHORSE_FLAG_DELETABLE = 0x10000000
} SeahorseFlags;

#define SEAHORSE_TYPE_FLAGS (seahorse_flags_get_type ())
enum  {
	SEAHORSE_OBJECT_0_PROPERTY,
	SEAHORSE_OBJECT_PLACE_PROPERTY,
	SEAHORSE_OBJECT_ICON_PROPERTY,
	SEAHORSE_OBJECT_LABEL_PROPERTY,
	SEAHORSE_OBJECT_MARKUP_PROPERTY,
	SEAHORSE_OBJECT_NICKNAME_PROPERTY,
	SEAHORSE_OBJECT_IDENTIFIER_PROPERTY,
	SEAHORSE_OBJECT_USAGE_PROPERTY,
	SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY,
	SEAHORSE_OBJECT_DELETABLE_PROPERTY,
	SEAHORSE_OBJECT_EXPORTABLE_PROPERTY,
	SEAHORSE_OBJECT_NUM_PROPERTIES
};
static GParamSpec* seahorse_object_properties[SEAHORSE_OBJECT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SeahorseObject {
	GObject parent_instance;
	SeahorseObjectPrivate * priv;
};

struct _SeahorseObjectClass {
	GObjectClass parent_class;
};

struct _SeahorsePlaceIface {
	GTypeInterface parent_iface;
	void (*load) (SeahorsePlace* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*load_finish) (SeahorsePlace* self, GAsyncResult* _res_, GError** error);
	gchar* (*get_label) (SeahorsePlace* self);
	void (*set_label) (SeahorsePlace* self, const gchar* value);
	gchar* (*get_description) (SeahorsePlace* self);
	gchar* (*get_uri) (SeahorsePlace* self);
	GIcon* (*get_icon) (SeahorsePlace* self);
	GActionGroup* (*get_actions) (SeahorsePlace* self);
	const gchar* (*get_action_prefix) (SeahorsePlace* self);
	GMenuModel* (*get_menu_model) (SeahorsePlace* self);
};

struct _SeahorseObjectPrivate {
	SeahorsePlace* _place;
	GIcon* _icon;
	gchar* _label;
	gchar* _markup;
	gboolean markup_explicit;
	gchar* _nickname;
	gboolean nickname_explicit;
	gchar* _identifier;
	SeahorseUsage _usage;
	SeahorseFlags _object_flags;
};

static gint SeahorseObject_private_offset;
static gpointer seahorse_object_parent_class = NULL;

GType seahorse_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseObject, g_object_unref)
GType seahorse_place_get_type (void) G_GNUC_CONST;
GType seahorse_usage_get_type (void) G_GNUC_CONST;
GType seahorse_flags_get_type (void) G_GNUC_CONST;
SeahorseObject* seahorse_object_new (void);
SeahorseObject* seahorse_object_construct (GType object_type);
SeahorseFlags seahorse_object_get_flags (SeahorseObject* self);
SeahorseFlags seahorse_object_get_object_flags (SeahorseObject* self);
void seahorse_object_set_flags (SeahorseObject* self,
                                SeahorseFlags flags);
void seahorse_object_set_object_flags (SeahorseObject* self,
                                       SeahorseFlags value);
static void seahorse_object_recalculate_label (SeahorseObject* self);
const gchar* seahorse_object_get_label (SeahorseObject* self);
void seahorse_object_set_markup (SeahorseObject* self,
                                 const gchar* value);
void seahorse_object_set_nickname (SeahorseObject* self,
                                   const gchar* value);
SeahorsePlace* seahorse_object_get_place (SeahorseObject* self);
void seahorse_object_set_place (SeahorseObject* self,
                                SeahorsePlace* value);
GIcon* seahorse_object_get_icon (SeahorseObject* self);
void seahorse_object_set_icon (SeahorseObject* self,
                               GIcon* value);
void seahorse_object_set_label (SeahorseObject* self,
                                const gchar* value);
const gchar* seahorse_object_get_markup (SeahorseObject* self);
const gchar* seahorse_object_get_nickname (SeahorseObject* self);
const gchar* seahorse_object_get_identifier (SeahorseObject* self);
void seahorse_object_set_identifier (SeahorseObject* self,
                                     const gchar* value);
SeahorseUsage seahorse_object_get_usage (SeahorseObject* self);
void seahorse_object_set_usage (SeahorseObject* self,
                                SeahorseUsage value);
gboolean seahorse_object_get_deletable (SeahorseObject* self);
gboolean seahorse_object_get_exportable (SeahorseObject* self);
static void seahorse_object_finalize (GObject * obj);
static void _vala_seahorse_object_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_seahorse_object_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
seahorse_object_get_instance_private (SeahorseObject* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseObject_private_offset);
}

SeahorseObject*
seahorse_object_construct (GType object_type)
{
	SeahorseObject * self = NULL;
#line 114 "../common/object.vala"
	self = (SeahorseObject*) g_object_new (object_type, NULL);
#line 114 "../common/object.vala"
	return self;
#line 198 "object.c"
}

SeahorseObject*
seahorse_object_new (void)
{
#line 114 "../common/object.vala"
	return seahorse_object_construct (SEAHORSE_TYPE_OBJECT);
#line 206 "object.c"
}

SeahorseFlags
seahorse_object_get_flags (SeahorseObject* self)
{
	SeahorseFlags result = 0;
	SeahorseFlags _tmp0_;
#line 117 "../common/object.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 118 "../common/object.vala"
	_tmp0_ = self->priv->_object_flags;
#line 118 "../common/object.vala"
	result = _tmp0_;
#line 118 "../common/object.vala"
	return result;
#line 222 "object.c"
}

void
seahorse_object_set_flags (SeahorseObject* self,
                           SeahorseFlags flags)
{
#line 121 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 122 "../common/object.vala"
	seahorse_object_set_object_flags (self, flags);
#line 233 "object.c"
}

static void
seahorse_object_recalculate_label (SeahorseObject* self)
{
#line 126 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 127 "../common/object.vala"
	if (!self->priv->markup_explicit) {
#line 243 "object.c"
		const gchar* _tmp0_ = NULL;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 128 "../common/object.vala"
		_tmp1_ = seahorse_object_get_label (self);
#line 128 "../common/object.vala"
		_tmp2_ = _tmp1_;
#line 128 "../common/object.vala"
		_tmp0_ = _tmp2_;
#line 128 "../common/object.vala"
		if (_tmp0_ == NULL) {
#line 128 "../common/object.vala"
			_tmp0_ = "";
#line 259 "object.c"
		}
#line 128 "../common/object.vala"
		_tmp3_ = g_markup_escape_text (_tmp0_, (gssize) -1);
#line 128 "../common/object.vala"
		_tmp4_ = _tmp3_;
#line 128 "../common/object.vala"
		seahorse_object_set_markup (self, _tmp4_);
#line 128 "../common/object.vala"
		_g_free0 (_tmp4_);
#line 129 "../common/object.vala"
		g_object_notify ((GObject*) self, "markup");
#line 271 "object.c"
	}
#line 132 "../common/object.vala"
	if (!self->priv->nickname_explicit) {
#line 275 "object.c"
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 133 "../common/object.vala"
		_tmp6_ = seahorse_object_get_label (self);
#line 133 "../common/object.vala"
		_tmp7_ = _tmp6_;
#line 133 "../common/object.vala"
		_tmp5_ = _tmp7_;
#line 133 "../common/object.vala"
		if (_tmp5_ == NULL) {
#line 133 "../common/object.vala"
			_tmp5_ = "";
#line 289 "object.c"
		}
#line 133 "../common/object.vala"
		seahorse_object_set_nickname (self, _tmp5_);
#line 134 "../common/object.vala"
		g_object_notify ((GObject*) self, "nickname");
#line 295 "object.c"
	}
}

SeahorsePlace*
seahorse_object_get_place (SeahorseObject* self)
{
	SeahorsePlace* result;
	SeahorsePlace* _tmp0_;
#line 32 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../common/object.vala"
	_tmp0_ = self->priv->_place;
#line 32 "../common/object.vala"
	result = _tmp0_;
#line 32 "../common/object.vala"
	return result;
#line 312 "object.c"
}

void
seahorse_object_set_place (SeahorseObject* self,
                           SeahorsePlace* value)
{
#line 32 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 32 "../common/object.vala"
	if (seahorse_object_get_place (self) != value) {
#line 32 "../common/object.vala"
		self->priv->_place = value;
#line 32 "../common/object.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_PLACE_PROPERTY]);
#line 327 "object.c"
	}
}

GIcon*
seahorse_object_get_icon (SeahorseObject* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 37 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../common/object.vala"
	_tmp0_ = self->priv->_icon;
#line 37 "../common/object.vala"
	result = _tmp0_;
#line 37 "../common/object.vala"
	return result;
#line 344 "object.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../common/object.vala"
	return self ? g_object_ref (self) : NULL;
#line 352 "object.c"
}

void
seahorse_object_set_icon (SeahorseObject* self,
                          GIcon* value)
{
#line 37 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 37 "../common/object.vala"
	if (seahorse_object_get_icon (self) != value) {
#line 363 "object.c"
		GIcon* _tmp0_;
#line 37 "../common/object.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../common/object.vala"
		_g_object_unref0 (self->priv->_icon);
#line 37 "../common/object.vala"
		self->priv->_icon = _tmp0_;
#line 37 "../common/object.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_ICON_PROPERTY]);
#line 373 "object.c"
	}
}

const gchar*
seahorse_object_get_label (SeahorseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../common/object.vala"
	_tmp0_ = self->priv->_label;
#line 43 "../common/object.vala"
	result = _tmp0_;
#line 43 "../common/object.vala"
	return result;
#line 390 "object.c"
}

void
seahorse_object_set_label (SeahorseObject* self,
                           const gchar* value)
{
	gchar* _tmp0_;
#line 44 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 45 "../common/object.vala"
	_tmp0_ = g_strdup (value);
#line 45 "../common/object.vala"
	_g_free0 (self->priv->_label);
#line 45 "../common/object.vala"
	self->priv->_label = _tmp0_;
#line 46 "../common/object.vala"
	seahorse_object_recalculate_label (self);
#line 44 "../common/object.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_LABEL_PROPERTY]);
#line 410 "object.c"
}

const gchar*
seahorse_object_get_markup (SeahorseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../common/object.vala"
	_tmp0_ = self->priv->_markup;
#line 55 "../common/object.vala"
	result = _tmp0_;
#line 55 "../common/object.vala"
	return result;
#line 426 "object.c"
}

void
seahorse_object_set_markup (SeahorseObject* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 56 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 57 "../common/object.vala"
	self->priv->markup_explicit = TRUE;
#line 58 "../common/object.vala"
	_tmp0_ = g_strdup (value);
#line 58 "../common/object.vala"
	_g_free0 (self->priv->_markup);
#line 58 "../common/object.vala"
	self->priv->_markup = _tmp0_;
#line 56 "../common/object.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_MARKUP_PROPERTY]);
#line 446 "object.c"
}

const gchar*
seahorse_object_get_nickname (SeahorseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 70 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../common/object.vala"
	_tmp0_ = self->priv->_nickname;
#line 70 "../common/object.vala"
	result = _tmp0_;
#line 70 "../common/object.vala"
	return result;
#line 462 "object.c"
}

void
seahorse_object_set_nickname (SeahorseObject* self,
                              const gchar* value)
{
	gchar* _tmp0_;
#line 71 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 72 "../common/object.vala"
	self->priv->nickname_explicit = TRUE;
#line 73 "../common/object.vala"
	_tmp0_ = g_strdup (value);
#line 73 "../common/object.vala"
	_g_free0 (self->priv->_nickname);
#line 73 "../common/object.vala"
	self->priv->_nickname = _tmp0_;
#line 71 "../common/object.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_NICKNAME_PROPERTY]);
#line 482 "object.c"
}

const gchar*
seahorse_object_get_identifier (SeahorseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 86 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../common/object.vala"
	_tmp0_ = self->priv->_identifier;
#line 86 "../common/object.vala"
	result = _tmp0_;
#line 86 "../common/object.vala"
	return result;
#line 498 "object.c"
}

void
seahorse_object_set_identifier (SeahorseObject* self,
                                const gchar* value)
{
	gchar* _tmp0_;
#line 87 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 88 "../common/object.vala"
	_tmp0_ = g_strdup (value);
#line 88 "../common/object.vala"
	_g_free0 (self->priv->_identifier);
#line 88 "../common/object.vala"
	self->priv->_identifier = _tmp0_;
#line 87 "../common/object.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_IDENTIFIER_PROPERTY]);
#line 516 "object.c"
}

SeahorseUsage
seahorse_object_get_usage (SeahorseObject* self)
{
	SeahorseUsage result;
	SeahorseUsage _tmp0_;
#line 97 "../common/object.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 97 "../common/object.vala"
	_tmp0_ = self->priv->_usage;
#line 97 "../common/object.vala"
	result = _tmp0_;
#line 97 "../common/object.vala"
	return result;
#line 532 "object.c"
}

void
seahorse_object_set_usage (SeahorseObject* self,
                           SeahorseUsage value)
{
#line 97 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 97 "../common/object.vala"
	if (seahorse_object_get_usage (self) != value) {
#line 97 "../common/object.vala"
		self->priv->_usage = value;
#line 97 "../common/object.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_USAGE_PROPERTY]);
#line 547 "object.c"
	}
}

SeahorseFlags
seahorse_object_get_object_flags (SeahorseObject* self)
{
	SeahorseFlags result;
	SeahorseFlags _tmp0_;
#line 102 "../common/object.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 102 "../common/object.vala"
	_tmp0_ = self->priv->_object_flags;
#line 102 "../common/object.vala"
	result = _tmp0_;
#line 102 "../common/object.vala"
	return result;
#line 564 "object.c"
}

void
seahorse_object_set_object_flags (SeahorseObject* self,
                                  SeahorseFlags value)
{
#line 102 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 102 "../common/object.vala"
	if (seahorse_object_get_object_flags (self) != value) {
#line 102 "../common/object.vala"
		self->priv->_object_flags = value;
#line 102 "../common/object.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY]);
#line 579 "object.c"
	}
}

gboolean
seahorse_object_get_deletable (SeahorseObject* self)
{
	gboolean result;
	SeahorseFlags _tmp0_;
#line 107 "../common/object.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../common/object.vala"
	_tmp0_ = self->priv->_object_flags;
#line 107 "../common/object.vala"
	result = (_tmp0_ & SEAHORSE_FLAG_DELETABLE) == SEAHORSE_FLAG_DELETABLE;
#line 107 "../common/object.vala"
	return result;
#line 596 "object.c"
}

gboolean
seahorse_object_get_exportable (SeahorseObject* self)
{
	gboolean result;
	SeahorseFlags _tmp0_;
#line 112 "../common/object.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 112 "../common/object.vala"
	_tmp0_ = self->priv->_object_flags;
#line 112 "../common/object.vala"
	result = (_tmp0_ & SEAHORSE_FLAG_EXPORTABLE) == SEAHORSE_FLAG_EXPORTABLE;
#line 112 "../common/object.vala"
	return result;
#line 612 "object.c"
}

static void
seahorse_object_class_init (SeahorseObjectClass * klass,
                            gpointer klass_data)
{
#line 26 "../common/object.vala"
	seahorse_object_parent_class = g_type_class_peek_parent (klass);
#line 26 "../common/object.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseObject_private_offset);
#line 26 "../common/object.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_object_get_property;
#line 26 "../common/object.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_object_set_property;
#line 26 "../common/object.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_object_finalize;
#line 629 "object.c"
	/**
	     * The place this Object came from.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_PLACE_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_PLACE_PROPERTY] = g_param_spec_object ("place", "place", "place", SEAHORSE_TYPE_PLACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 635 "object.c"
	/**
	     * Stock ID for this Object.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_ICON_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 641 "object.c"
	/**
	     * This object's displayable label.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_LABEL_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 647 "object.c"
	/**
	     * This object's displayable markup.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_MARKUP_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_MARKUP_PROPERTY] = g_param_spec_string ("markup", "markup", "markup", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 653 "object.c"
	/**
	     * This object's short name.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_NICKNAME_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_NICKNAME_PROPERTY] = g_param_spec_string ("nickname", "nickname", "nickname", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 659 "object.c"
	/**
	     * Displayable ID for the object.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_IDENTIFIER_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_IDENTIFIER_PROPERTY] = g_param_spec_string ("identifier", "identifier", "identifier", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 665 "object.c"
	/**
	     * How this object is used.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_USAGE_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_USAGE_PROPERTY] = g_param_spec_enum ("usage", "usage", "usage", SEAHORSE_TYPE_USAGE, SEAHORSE_USAGE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 671 "object.c"
	/**
	     * This object's flags.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY] = g_param_spec_flags ("object-flags", "object-flags", "object-flags", SEAHORSE_TYPE_FLAGS, SEAHORSE_FLAG_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 677 "object.c"
	/**
	     * Whether this Object can be deleted.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_DELETABLE_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_DELETABLE_PROPERTY] = g_param_spec_boolean ("deletable", "deletable", "deletable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 683 "object.c"
	/**
	     * Whether this Object can be exported.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_EXPORTABLE_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_EXPORTABLE_PROPERTY] = g_param_spec_boolean ("exportable", "exportable", "exportable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 689 "object.c"
}

static void
seahorse_object_instance_init (SeahorseObject * self,
                               gpointer klass)
{
	GThemedIcon* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 26 "../common/object.vala"
	self->priv = seahorse_object_get_instance_private (self);
#line 32 "../common/object.vala"
	self->priv->_place = NULL;
#line 37 "../common/object.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("gtk-missing-image");
#line 37 "../common/object.vala"
	self->priv->_icon = (GIcon*) _tmp0_;
#line 49 "../common/object.vala"
	_tmp1_ = g_strdup ("");
#line 49 "../common/object.vala"
	self->priv->_label = _tmp1_;
#line 61 "../common/object.vala"
	_tmp2_ = g_strdup ("");
#line 61 "../common/object.vala"
	self->priv->_markup = _tmp2_;
#line 76 "../common/object.vala"
	_tmp3_ = g_strdup ("");
#line 76 "../common/object.vala"
	self->priv->_nickname = _tmp3_;
#line 91 "../common/object.vala"
	_tmp4_ = g_strdup ("");
#line 91 "../common/object.vala"
	self->priv->_identifier = _tmp4_;
#line 97 "../common/object.vala"
	self->priv->_usage = SEAHORSE_USAGE_NONE;
#line 102 "../common/object.vala"
	self->priv->_object_flags = SEAHORSE_FLAG_NONE;
#line 729 "object.c"
}

static void
seahorse_object_finalize (GObject * obj)
{
	SeahorseObject * self;
#line 26 "../common/object.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_OBJECT, SeahorseObject);
#line 37 "../common/object.vala"
	_g_object_unref0 (self->priv->_icon);
#line 49 "../common/object.vala"
	_g_free0 (self->priv->_label);
#line 61 "../common/object.vala"
	_g_free0 (self->priv->_markup);
#line 76 "../common/object.vala"
	_g_free0 (self->priv->_nickname);
#line 91 "../common/object.vala"
	_g_free0 (self->priv->_identifier);
#line 26 "../common/object.vala"
	G_OBJECT_CLASS (seahorse_object_parent_class)->finalize (obj);
#line 750 "object.c"
}

/**
 * The base class for passwords/keys and others that are handled by Seahorse.
 */
GType
seahorse_object_get_type (void)
{
	static volatile gsize seahorse_object_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseObject), 0, (GInstanceInitFunc) seahorse_object_instance_init, NULL };
		GType seahorse_object_type_id;
		seahorse_object_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseObject", &g_define_type_info, 0);
		SeahorseObject_private_offset = g_type_add_instance_private (seahorse_object_type_id, sizeof (SeahorseObjectPrivate));
		g_once_init_leave (&seahorse_object_type_id__volatile, seahorse_object_type_id);
	}
	return seahorse_object_type_id__volatile;
}

static void
_vala_seahorse_object_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SeahorseObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_OBJECT, SeahorseObject);
#line 26 "../common/object.vala"
	switch (property_id) {
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_PLACE_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_object (value, seahorse_object_get_place (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_ICON_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_object (value, seahorse_object_get_icon (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_LABEL_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_string (value, seahorse_object_get_label (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_MARKUP_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_string (value, seahorse_object_get_markup (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_NICKNAME_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_string (value, seahorse_object_get_nickname (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_IDENTIFIER_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_string (value, seahorse_object_get_identifier (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_USAGE_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_enum (value, seahorse_object_get_usage (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_flags (value, seahorse_object_get_object_flags (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_DELETABLE_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_boolean (value, seahorse_object_get_deletable (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_EXPORTABLE_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_boolean (value, seahorse_object_get_exportable (self));
#line 26 "../common/object.vala"
		break;
#line 840 "object.c"
		default:
#line 26 "../common/object.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../common/object.vala"
		break;
#line 846 "object.c"
	}
}

static void
_vala_seahorse_object_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SeahorseObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_OBJECT, SeahorseObject);
#line 26 "../common/object.vala"
	switch (property_id) {
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_PLACE_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_place (self, g_value_get_object (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_ICON_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_icon (self, g_value_get_object (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_LABEL_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_label (self, g_value_get_string (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_MARKUP_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_markup (self, g_value_get_string (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_NICKNAME_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_nickname (self, g_value_get_string (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_IDENTIFIER_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_identifier (self, g_value_get_string (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_USAGE_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_usage (self, g_value_get_enum (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_object_flags (self, g_value_get_flags (value));
#line 26 "../common/object.vala"
		break;
#line 908 "object.c"
		default:
#line 26 "../common/object.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../common/object.vala"
		break;
#line 914 "object.c"
	}
}

