/* util.c generated by valac 0.44.0, the Vala compiler
 * generated from util.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2004-2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

void seahorse_util_show_error (GtkWidget* parent,
                               const gchar* heading,
                               const gchar* message);
gchar* seahorse_util_get_display_date_string (guint64 time);
GtkBuilder* seahorse_util_load_built_contents (GtkContainer* frame,
                                               const gchar* name);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../common/util.vala"
	return self ? g_object_ref (self) : NULL;
#line 48 "util.c"
}

void
seahorse_util_show_error (GtkWidget* parent,
                          const gchar* heading,
                          const gchar* message)
{
	GtkWindow* window = NULL;
	GtkMessageDialog* dialog = NULL;
	GtkWindow* _tmp2_;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp6_;
	GtkMessageDialog* _tmp7_;
#line 28 "../common/util.vala"
	window = NULL;
#line 30 "../common/util.vala"
	if (message == NULL) {
#line 31 "../common/util.vala"
		message = "";
#line 68 "util.c"
	}
#line 33 "../common/util.vala"
	if (parent != NULL) {
#line 34 "../common/util.vala"
		if (!G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ())) {
#line 74 "util.c"
			GtkWidget* _tmp0_;
#line 35 "../common/util.vala"
			_tmp0_ = gtk_widget_get_toplevel (parent);
#line 35 "../common/util.vala"
			parent = _tmp0_;
#line 80 "util.c"
		}
#line 36 "../common/util.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ())) {
#line 84 "util.c"
			GtkWindow* _tmp1_;
#line 37 "../common/util.vala"
			_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (parent, gtk_window_get_type (), GtkWindow));
#line 37 "../common/util.vala"
			_g_object_unref0 (window);
#line 37 "../common/util.vala"
			window = _tmp1_;
#line 92 "util.c"
		}
	}
#line 40 "../common/util.vala"
	_tmp2_ = window;
#line 40 "../common/util.vala"
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp2_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "");
#line 40 "../common/util.vala"
	g_object_ref_sink (_tmp3_);
#line 40 "../common/util.vala"
	dialog = _tmp3_;
#line 43 "../common/util.vala"
	if (heading == NULL) {
#line 105 "util.c"
		GtkMessageDialog* _tmp4_;
#line 44 "../common/util.vala"
		_tmp4_ = dialog;
#line 44 "../common/util.vala"
		g_object_set ((GObject*) _tmp4_, "text", message, NULL);
#line 111 "util.c"
	} else {
		GtkMessageDialog* _tmp5_;
#line 46 "../common/util.vala"
		_tmp5_ = dialog;
#line 46 "../common/util.vala"
		g_object_set ((GObject*) _tmp5_, "text", heading, "secondary-text", message, NULL);
#line 118 "util.c"
	}
#line 48 "../common/util.vala"
	_tmp6_ = dialog;
#line 48 "../common/util.vala"
	gtk_dialog_run ((GtkDialog*) _tmp6_);
#line 49 "../common/util.vala"
	_tmp7_ = dialog;
#line 49 "../common/util.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp7_);
#line 25 "../common/util.vala"
	_g_object_unref0 (dialog);
#line 25 "../common/util.vala"
	_g_object_unref0 (window);
#line 132 "util.c"
}

gchar*
seahorse_util_get_display_date_string (guint64 time)
{
	gchar* result = NULL;
	GDateTime* created_date = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
#line 54 "../common/util.vala"
	if (time == ((guint64) 0)) {
#line 145 "util.c"
		gchar* _tmp0_;
#line 55 "../common/util.vala"
		_tmp0_ = g_strdup ("");
#line 55 "../common/util.vala"
		result = _tmp0_;
#line 55 "../common/util.vala"
		return result;
#line 153 "util.c"
	}
#line 56 "../common/util.vala"
	_tmp1_ = g_date_time_new_from_unix_utc ((gint64) time);
#line 56 "../common/util.vala"
	created_date = _tmp1_;
#line 57 "../common/util.vala"
	_tmp2_ = created_date;
#line 57 "../common/util.vala"
	_tmp3_ = g_date_time_format (_tmp2_, "%x");
#line 57 "../common/util.vala"
	result = _tmp3_;
#line 57 "../common/util.vala"
	_g_date_time_unref0 (created_date);
#line 57 "../common/util.vala"
	return result;
#line 169 "util.c"
}

GtkBuilder*
seahorse_util_load_built_contents (GtkContainer* frame,
                                   const gchar* name)
{
	GtkBuilder* result = NULL;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	gchar* path = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 60 "../common/util.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 62 "../common/util.vala"
	_tmp0_ = gtk_builder_new ();
#line 62 "../common/util.vala"
	builder = _tmp0_;
#line 63 "../common/util.vala"
	_tmp1_ = g_strdup_printf ("/org/gnome/Seahorse/seahorse-%s.ui", name);
#line 63 "../common/util.vala"
	path = _tmp1_;
#line 65 "../common/util.vala"
	if (frame != NULL) {
#line 65 "../common/util.vala"
		_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (frame, gtk_dialog_get_type ());
#line 197 "util.c"
	} else {
#line 65 "../common/util.vala"
		_tmp2_ = FALSE;
#line 201 "util.c"
	}
#line 65 "../common/util.vala"
	if (_tmp2_) {
#line 205 "util.c"
		GtkBox* _tmp3_;
#line 66 "../common/util.vala"
		_tmp3_ = gtk_dialog_get_content_area (G_TYPE_CHECK_INSTANCE_CAST (frame, gtk_dialog_get_type (), GtkDialog));
#line 66 "../common/util.vala"
		frame = (GtkContainer*) _tmp3_;
#line 211 "util.c"
	}
	{
		GtkBuilder* _tmp4_;
		const gchar* _tmp5_;
		GObject* obj = NULL;
		GtkBuilder* _tmp6_;
		GObject* _tmp7_;
		GObject* _tmp8_;
		GObject* _tmp9_;
#line 69 "../common/util.vala"
		_tmp4_ = builder;
#line 69 "../common/util.vala"
		_tmp5_ = path;
#line 69 "../common/util.vala"
		gtk_builder_add_from_resource (_tmp4_, _tmp5_, &_inner_error0_);
#line 69 "../common/util.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "util.c"
			goto __catch8_g_error;
		}
#line 70 "../common/util.vala"
		_tmp6_ = builder;
#line 70 "../common/util.vala"
		_tmp7_ = gtk_builder_get_object (_tmp6_, name);
#line 70 "../common/util.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 70 "../common/util.vala"
		obj = _tmp8_;
#line 71 "../common/util.vala"
		_tmp9_ = obj;
#line 71 "../common/util.vala"
		if (_tmp9_ == NULL) {
#line 244 "util.c"
			const gchar* _tmp10_;
#line 72 "../common/util.vala"
			_tmp10_ = path;
#line 72 "../common/util.vala"
			g_critical ("util.vala:72: Couldn't find object named %s in %s", name, _tmp10_);
#line 250 "util.c"
		} else {
#line 73 "../common/util.vala"
			if (frame != NULL) {
#line 254 "util.c"
				GtkWidget* widget = NULL;
				GObject* _tmp11_;
				GtkWidget* _tmp12_;
				GtkWidget* _tmp13_;
				GtkWidget* _tmp14_;
#line 74 "../common/util.vala"
				_tmp11_ = obj;
#line 74 "../common/util.vala"
				_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
#line 74 "../common/util.vala"
				widget = _tmp12_;
#line 75 "../common/util.vala"
				_tmp13_ = widget;
#line 75 "../common/util.vala"
				gtk_container_add (frame, _tmp13_);
#line 76 "../common/util.vala"
				_tmp14_ = widget;
#line 76 "../common/util.vala"
				gtk_widget_show (_tmp14_);
#line 73 "../common/util.vala"
				_g_object_unref0 (widget);
#line 276 "util.c"
			}
		}
#line 68 "../common/util.vala"
		_g_object_unref0 (obj);
#line 281 "util.c"
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 68 "../common/util.vala"
		err = _inner_error0_;
#line 68 "../common/util.vala"
		_inner_error0_ = NULL;
#line 79 "../common/util.vala"
		_tmp15_ = path;
#line 79 "../common/util.vala"
		_tmp16_ = err;
#line 79 "../common/util.vala"
		_tmp17_ = _tmp16_->message;
#line 79 "../common/util.vala"
		g_critical ("util.vala:79: Couldn't load %s: %s", _tmp15_, _tmp17_);
#line 68 "../common/util.vala"
		_g_error_free0 (err);
#line 304 "util.c"
	}
	__finally8:
#line 68 "../common/util.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../common/util.vala"
		_g_free0 (path);
#line 68 "../common/util.vala"
		_g_object_unref0 (builder);
#line 68 "../common/util.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "../common/util.vala"
		g_clear_error (&_inner_error0_);
#line 68 "../common/util.vala"
		return NULL;
#line 319 "util.c"
	}
#line 82 "../common/util.vala"
	result = builder;
#line 82 "../common/util.vala"
	_g_free0 (path);
#line 82 "../common/util.vala"
	return result;
#line 327 "util.c"
}

