/* import-dialog.c generated by valac 0.44.0, the Vala compiler
 * generated from import-dialog.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Author: Stef Walter <stefw@collabora.co.uk>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <ui/gcr-ui.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gcr/gcr-base.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "seahorse-common.h"

#define SEAHORSE_TYPE_IMPORT_DIALOG (seahorse_import_dialog_get_type ())
#define SEAHORSE_IMPORT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialog))
#define SEAHORSE_IMPORT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialogClass))
#define SEAHORSE_IS_IMPORT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_IMPORT_DIALOG))
#define SEAHORSE_IS_IMPORT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_IMPORT_DIALOG))
#define SEAHORSE_IMPORT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialogClass))

typedef struct _SeahorseImportDialog SeahorseImportDialog;
typedef struct _SeahorseImportDialogClass SeahorseImportDialogClass;
typedef struct _SeahorseImportDialogPrivate SeahorseImportDialogPrivate;
enum  {
	SEAHORSE_IMPORT_DIALOG_0_PROPERTY,
	SEAHORSE_IMPORT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* seahorse_import_dialog_properties[SEAHORSE_IMPORT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SeahorseImportDialog {
	GtkDialog parent_instance;
	SeahorseImportDialogPrivate * priv;
};

struct _SeahorseImportDialogClass {
	GtkDialogClass parent_class;
};

struct _SeahorseImportDialogPrivate {
	GcrViewerWidget* viewer;
	GcrImportButton* import;
};

static gint SeahorseImportDialog_private_offset;
static gpointer seahorse_import_dialog_parent_class = NULL;

GType seahorse_import_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseImportDialog, g_object_unref)
SeahorseImportDialog* seahorse_import_dialog_new (GtkWindow* parent);
SeahorseImportDialog* seahorse_import_dialog_construct (GType object_type,
                                                        GtkWindow* parent);
static void __lambda19_ (SeahorseImportDialog* self);
static void ___lambda19__gcr_import_button_importing (GcrImportButton* _sender,
                                               GObject* importer,
                                               gpointer self);
static void seahorse_import_dialog_on_import_button_imported (SeahorseImportDialog* self,
                                                       GObject* importer,
                                                       GError* _error_);
static void _seahorse_import_dialog_on_import_button_imported_gcr_import_button_imported (GcrImportButton* _sender,
                                                                                   GObject* importer,
                                                                                   GError* _error_,
                                                                                   gpointer self);
static void __lambda20_ (SeahorseImportDialog* self,
                  GcrViewerWidget* v,
                  GcrRenderer* r,
                  GcrParsed* parsed);
static void ___lambda20__gcr_viewer_widget_added (GcrViewerWidget* _sender,
                                           GcrRenderer* renderer,
                                           GcrParsed* parsed,
                                           gpointer self);
void seahorse_import_dialog_add_uris (SeahorseImportDialog* self,
                                      gchar** uris,
                                      gint uris_length1);
void seahorse_import_dialog_add_text (SeahorseImportDialog* self,
                                      const gchar* display_name,
                                      const gchar* text);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void seahorse_import_dialog_finalize (GObject * obj);

static inline gpointer
seahorse_import_dialog_get_instance_private (SeahorseImportDialog* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseImportDialog_private_offset);
}

static void
__lambda19_ (SeahorseImportDialog* self)
{
	GcrViewerWidget* _tmp0_;
#line 42 "../src/import-dialog.vala"
	_tmp0_ = self->priv->viewer;
#line 42 "../src/import-dialog.vala"
	gcr_viewer_widget_clear_error (_tmp0_);
#line 120 "import-dialog.c"
}

static void
___lambda19__gcr_import_button_importing (GcrImportButton* _sender,
                                          GObject* importer,
                                          gpointer self)
{
#line 42 "../src/import-dialog.vala"
	__lambda19_ ((SeahorseImportDialog*) self);
#line 130 "import-dialog.c"
}

static void
_seahorse_import_dialog_on_import_button_imported_gcr_import_button_imported (GcrImportButton* _sender,
                                                                              GObject* importer,
                                                                              GError* _error_,
                                                                              gpointer self)
{
#line 43 "../src/import-dialog.vala"
	seahorse_import_dialog_on_import_button_imported ((SeahorseImportDialog*) self, importer, _error_);
#line 141 "import-dialog.c"
}

static void
__lambda20_ (SeahorseImportDialog* self,
             GcrViewerWidget* v,
             GcrRenderer* r,
             GcrParsed* parsed)
{
	GcrImportButton* _tmp0_;
#line 47 "../src/import-dialog.vala"
	g_return_if_fail (v != NULL);
#line 47 "../src/import-dialog.vala"
	g_return_if_fail (r != NULL);
#line 47 "../src/import-dialog.vala"
	g_return_if_fail (parsed != NULL);
#line 47 "../src/import-dialog.vala"
	_tmp0_ = self->priv->import;
#line 47 "../src/import-dialog.vala"
	gcr_import_button_add_parsed (_tmp0_, parsed);
#line 161 "import-dialog.c"
}

static void
___lambda20__gcr_viewer_widget_added (GcrViewerWidget* _sender,
                                      GcrRenderer* renderer,
                                      GcrParsed* parsed,
                                      gpointer self)
{
#line 47 "../src/import-dialog.vala"
	__lambda20_ ((SeahorseImportDialog*) self, _sender, renderer, parsed);
#line 172 "import-dialog.c"
}

SeahorseImportDialog*
seahorse_import_dialog_construct (GType object_type,
                                  GtkWindow* parent)
{
	SeahorseImportDialog * self = NULL;
	GtkWidget* button = NULL;
	GtkButton* _tmp0_;
	GcrImportButton* _tmp1_;
	GcrImportButton* _tmp2_;
	GcrImportButton* _tmp3_;
	GcrImportButton* _tmp4_;
	GtkStyleContext* _tmp5_;
	GcrImportButton* _tmp6_;
	GcrImportButton* _tmp7_;
	GcrImportButton* _tmp8_;
	GcrViewerWidget* _tmp9_;
	GcrViewerWidget* _tmp10_;
	GcrViewerWidget* _tmp11_;
	GtkBox* _tmp12_;
	GcrViewerWidget* _tmp13_;
#line 28 "../src/import-dialog.vala"
	self = (SeahorseImportDialog*) g_object_new (object_type, "transient-for", parent, "title", _ ("Data to be imported"), "use-header-bar", 1, NULL);
#line 34 "../src/import-dialog.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_mnemonic (_ ("_Cancel"));
#line 34 "../src/import-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 34 "../src/import-dialog.vala"
	button = (GtkWidget*) _tmp0_;
#line 35 "../src/import-dialog.vala"
	gtk_widget_show (button);
#line 36 "../src/import-dialog.vala"
	gtk_dialog_add_action_widget ((GtkDialog*) self, button, (gint) GTK_RESPONSE_CANCEL);
#line 38 "../src/import-dialog.vala"
	_tmp1_ = gcr_import_button_new (_ ("Import"));
#line 38 "../src/import-dialog.vala"
	g_object_ref_sink (_tmp1_);
#line 38 "../src/import-dialog.vala"
	_g_object_unref0 (self->priv->import);
#line 38 "../src/import-dialog.vala"
	self->priv->import = _tmp1_;
#line 39 "../src/import-dialog.vala"
	_tmp2_ = self->priv->import;
#line 39 "../src/import-dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp2_, GTK_ALIGN_END);
#line 40 "../src/import-dialog.vala"
	_tmp3_ = self->priv->import;
#line 40 "../src/import-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, TRUE);
#line 41 "../src/import-dialog.vala"
	_tmp4_ = self->priv->import;
#line 41 "../src/import-dialog.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 41 "../src/import-dialog.vala"
	gtk_style_context_add_class (_tmp5_, "suggested-action");
#line 42 "../src/import-dialog.vala"
	_tmp6_ = self->priv->import;
#line 42 "../src/import-dialog.vala"
	g_signal_connect_object (_tmp6_, "importing", (GCallback) ___lambda19__gcr_import_button_importing, self, 0);
#line 43 "../src/import-dialog.vala"
	_tmp7_ = self->priv->import;
#line 43 "../src/import-dialog.vala"
	g_signal_connect_object (_tmp7_, "imported", (GCallback) _seahorse_import_dialog_on_import_button_imported_gcr_import_button_imported, self, 0);
#line 44 "../src/import-dialog.vala"
	_tmp8_ = self->priv->import;
#line 44 "../src/import-dialog.vala"
	gtk_dialog_add_action_widget ((GtkDialog*) self, (GtkWidget*) _tmp8_, (gint) GTK_RESPONSE_OK);
#line 46 "../src/import-dialog.vala"
	_tmp9_ = gcr_viewer_widget_new ();
#line 46 "../src/import-dialog.vala"
	g_object_ref_sink (_tmp9_);
#line 46 "../src/import-dialog.vala"
	_g_object_unref0 (self->priv->viewer);
#line 46 "../src/import-dialog.vala"
	self->priv->viewer = _tmp9_;
#line 47 "../src/import-dialog.vala"
	_tmp10_ = self->priv->viewer;
#line 47 "../src/import-dialog.vala"
	g_signal_connect_object (_tmp10_, "added", (GCallback) ___lambda20__gcr_viewer_widget_added, self, 0);
#line 48 "../src/import-dialog.vala"
	_tmp11_ = self->priv->viewer;
#line 48 "../src/import-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp11_);
#line 49 "../src/import-dialog.vala"
	_tmp12_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 49 "../src/import-dialog.vala"
	_tmp13_ = self->priv->viewer;
#line 49 "../src/import-dialog.vala"
	gtk_box_pack_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_box_get_type (), GtkBox), (GtkWidget*) _tmp13_, TRUE, TRUE, (guint) 0);
#line 27 "../src/import-dialog.vala"
	_g_object_unref0 (button);
#line 27 "../src/import-dialog.vala"
	return self;
#line 267 "import-dialog.c"
}

SeahorseImportDialog*
seahorse_import_dialog_new (GtkWindow* parent)
{
#line 27 "../src/import-dialog.vala"
	return seahorse_import_dialog_construct (SEAHORSE_TYPE_IMPORT_DIALOG, parent);
#line 275 "import-dialog.c"
}

void
seahorse_import_dialog_add_uris (SeahorseImportDialog* self,
                                 gchar** uris,
                                 gint uris_length1)
{
#line 52 "../src/import-dialog.vala"
	g_return_if_fail (self != NULL);
#line 285 "import-dialog.c"
	{
		gchar** uri_collection = NULL;
		gint uri_collection_length1 = 0;
		gint _uri_collection_size_ = 0;
		gint uri_it = 0;
#line 53 "../src/import-dialog.vala"
		uri_collection = uris;
#line 53 "../src/import-dialog.vala"
		uri_collection_length1 = uris_length1;
#line 53 "../src/import-dialog.vala"
		for (uri_it = 0; uri_it < uris_length1; uri_it = uri_it + 1) {
#line 297 "import-dialog.c"
			gchar* _tmp0_;
			gchar* uri = NULL;
#line 53 "../src/import-dialog.vala"
			_tmp0_ = g_strdup (uri_collection[uri_it]);
#line 53 "../src/import-dialog.vala"
			uri = _tmp0_;
#line 304 "import-dialog.c"
			{
				GcrViewerWidget* _tmp1_;
				const gchar* _tmp2_;
				GFile* _tmp3_;
				GFile* _tmp4_;
#line 54 "../src/import-dialog.vala"
				_tmp1_ = self->priv->viewer;
#line 54 "../src/import-dialog.vala"
				_tmp2_ = uri;
#line 54 "../src/import-dialog.vala"
				_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 54 "../src/import-dialog.vala"
				_tmp4_ = _tmp3_;
#line 54 "../src/import-dialog.vala"
				gcr_viewer_widget_load_file (_tmp1_, _tmp4_);
#line 54 "../src/import-dialog.vala"
				_g_object_unref0 (_tmp4_);
#line 53 "../src/import-dialog.vala"
				_g_free0 (uri);
#line 324 "import-dialog.c"
			}
		}
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1499 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1499 "glib-2.0.vapi"
	res_length1 = -1;
#line 1499 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1500 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1500 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1500 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1501 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1501 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1501 "glib-2.0.vapi"
	_tmp3_ = _tmp2_;
#line 1501 "glib-2.0.vapi"
	_tmp3__length1 = _tmp2__length1;
#line 1501 "glib-2.0.vapi"
	if (result_length1) {
#line 1501 "glib-2.0.vapi"
		*result_length1 = _tmp3__length1;
#line 370 "import-dialog.c"
	}
#line 1501 "glib-2.0.vapi"
	result = _tmp3_;
#line 1501 "glib-2.0.vapi"
	return result;
#line 376 "import-dialog.c"
}

void
seahorse_import_dialog_add_text (SeahorseImportDialog* self,
                                 const gchar* display_name,
                                 const gchar* text)
{
	GcrViewerWidget* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 57 "../src/import-dialog.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/import-dialog.vala"
	g_return_if_fail (text != NULL);
#line 58 "../src/import-dialog.vala"
	_tmp0_ = self->priv->viewer;
#line 58 "../src/import-dialog.vala"
	_tmp1_ = string_get_data (text, &_tmp1__length1);
#line 58 "../src/import-dialog.vala"
	_tmp2_ = _tmp1_;
#line 58 "../src/import-dialog.vala"
	_tmp2__length1 = _tmp1__length1;
#line 58 "../src/import-dialog.vala"
	gcr_viewer_widget_load_data (_tmp0_, display_name, _tmp2_, (gsize) _tmp2__length1);
#line 403 "import-dialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 66 "../src/import-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 411 "import-dialog.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 66 "../src/import-dialog.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 419 "import-dialog.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 66 "../src/import-dialog.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 427 "import-dialog.c"
}

static void
seahorse_import_dialog_on_import_button_imported (SeahorseImportDialog* self,
                                                  GObject* importer,
                                                  GError* _error_)
{
#line 61 "../src/import-dialog.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/import-dialog.vala"
	g_return_if_fail (importer != NULL);
#line 62 "../src/import-dialog.vala"
	if (_error_ == NULL) {
#line 441 "import-dialog.c"
		gchar* uri = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GList* _tmp2_;
#line 63 "../src/import-dialog.vala"
		gtk_dialog_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
#line 65 "../src/import-dialog.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (importer, gcr_importer_get_type (), GcrImporter), "uri", &_tmp0_, NULL);
#line 65 "../src/import-dialog.vala"
		_tmp1_ = _tmp0_;
#line 65 "../src/import-dialog.vala"
		uri = _tmp1_;
#line 66 "../src/import-dialog.vala"
		_tmp2_ = seahorse_backend_get_registered ();
#line 456 "import-dialog.c"
		{
			GList* backend_collection = NULL;
			GList* backend_it = NULL;
#line 66 "../src/import-dialog.vala"
			backend_collection = _tmp2_;
#line 66 "../src/import-dialog.vala"
			for (backend_it = backend_collection; backend_it != NULL; backend_it = backend_it->next) {
#line 464 "import-dialog.c"
				SeahorseBackend* _tmp3_;
				SeahorseBackend* backend = NULL;
#line 66 "../src/import-dialog.vala"
				_tmp3_ = _g_object_ref0 ((SeahorseBackend*) backend_it->data);
#line 66 "../src/import-dialog.vala"
				backend = _tmp3_;
#line 471 "import-dialog.c"
				{
					SeahorsePlace* place = NULL;
					SeahorseBackend* _tmp4_;
					const gchar* _tmp5_;
					SeahorsePlace* _tmp6_;
					SeahorsePlace* _tmp7_;
#line 67 "../src/import-dialog.vala"
					_tmp4_ = backend;
#line 67 "../src/import-dialog.vala"
					_tmp5_ = uri;
#line 67 "../src/import-dialog.vala"
					_tmp6_ = seahorse_backend_lookup_place (_tmp4_, _tmp5_);
#line 67 "../src/import-dialog.vala"
					place = _tmp6_;
#line 68 "../src/import-dialog.vala"
					_tmp7_ = place;
#line 68 "../src/import-dialog.vala"
					if (_tmp7_ != NULL) {
#line 490 "import-dialog.c"
						SeahorsePlace* _tmp8_;
#line 69 "../src/import-dialog.vala"
						_tmp8_ = place;
#line 69 "../src/import-dialog.vala"
						seahorse_place_load (_tmp8_, NULL, NULL, NULL);
#line 496 "import-dialog.c"
					}
#line 66 "../src/import-dialog.vala"
					_g_object_unref0 (place);
#line 66 "../src/import-dialog.vala"
					_g_object_unref0 (backend);
#line 502 "import-dialog.c"
				}
			}
#line 66 "../src/import-dialog.vala"
			(backend_collection == NULL) ? NULL : (backend_collection = (_g_list_free__g_object_unref0_ (backend_collection), NULL));
#line 507 "import-dialog.c"
		}
#line 62 "../src/import-dialog.vala"
		_g_free0 (uri);
#line 511 "import-dialog.c"
	} else {
#line 73 "../src/import-dialog.vala"
		if (!g_error_matches (_error_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 515 "import-dialog.c"
			GcrViewerWidget* _tmp9_;
#line 74 "../src/import-dialog.vala"
			_tmp9_ = self->priv->viewer;
#line 74 "../src/import-dialog.vala"
			gcr_viewer_widget_show_error (_tmp9_, _ ("Import failed"), _error_);
#line 521 "import-dialog.c"
		}
	}
}

static void
seahorse_import_dialog_class_init (SeahorseImportDialogClass * klass,
                                   gpointer klass_data)
{
#line 22 "../src/import-dialog.vala"
	seahorse_import_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/import-dialog.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseImportDialog_private_offset);
#line 22 "../src/import-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_import_dialog_finalize;
#line 536 "import-dialog.c"
}

static void
seahorse_import_dialog_instance_init (SeahorseImportDialog * self,
                                      gpointer klass)
{
#line 22 "../src/import-dialog.vala"
	self->priv = seahorse_import_dialog_get_instance_private (self);
#line 545 "import-dialog.c"
}

static void
seahorse_import_dialog_finalize (GObject * obj)
{
	SeahorseImportDialog * self;
#line 22 "../src/import-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialog);
#line 24 "../src/import-dialog.vala"
	_g_object_unref0 (self->priv->viewer);
#line 25 "../src/import-dialog.vala"
	_g_object_unref0 (self->priv->import);
#line 22 "../src/import-dialog.vala"
	G_OBJECT_CLASS (seahorse_import_dialog_parent_class)->finalize (obj);
#line 560 "import-dialog.c"
}

GType
seahorse_import_dialog_get_type (void)
{
	static volatile gsize seahorse_import_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_import_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseImportDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_import_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseImportDialog), 0, (GInstanceInitFunc) seahorse_import_dialog_instance_init, NULL };
		GType seahorse_import_dialog_type_id;
		seahorse_import_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "SeahorseImportDialog", &g_define_type_info, 0);
		SeahorseImportDialog_private_offset = g_type_add_instance_private (seahorse_import_dialog_type_id, sizeof (SeahorseImportDialogPrivate));
		g_once_init_leave (&seahorse_import_dialog_type_id__volatile, seahorse_import_dialog_type_id);
	}
	return seahorse_import_dialog_type_id__volatile;
}

